From 4f3b94270f044ff5a3f124caaec15548cc18e308 Mon Sep 17 00:00:00 2001
From: James Gu <jgu@suse.com>
Date: Thu, 31 Aug 2017 14:47:47 -0700
URL: https://review.openstack.org/#/c/527858/
Subject: [PATCH] Add cassandra support

Support Cassandra db installation and Cassandra related
configurations for Monasca api and persister services
in devstack. Add Monasca rest API Cassandra plugin for
retrieving metric, dimension, measurement, statistics
and alarms.

Depends-On: I4bbe48f8fe550385de6ed3e14120850a8542c7c9
Change-Id: Ie60d668692e1f25f555dda2355f4e513d582736c
story: 2001231
task: 5759
(cherry picked from commit ba43f07726d060ac0a3e4d5289dc4ad3fde2397c)
---
 AUTHORS                                            |    5 +
 devstack/files/cassandra/cassandra_schema.cql      |   46 -
 devstack/files/cassandra/monasca_schema.cql        |   93 ++
 devstack/files/monasca-persister/persister.yml     |   54 +-
 devstack/lib/persister.sh                          |   49 +-
 devstack/plugin.sh                                 |   29 +-
 devstack/settings                                  |    2 +-
 docs/monasca-api-spec.md                           |   16 +-
 .../repositories/cassandra/metrics_repository.py   | 1214 ++++++++++++--------
 .../repositories/influxdb/metrics_repository.py    |   14 +-
 monasca_api/conf/cassandra.py                      |   43 +
 monasca_api/healthcheck/metrics_db_check.py        |    4 +-
 monasca_api/tests/test_metrics_db_health_check.py  |    9 +-
 monasca_api/tests/test_repositories.py             |  181 +--
 monasca_api/v2/reference/__init__.py               |    2 +-
 monasca_api/v2/reference/helpers.py                |   16 +-
 monasca_tempest_tests/tests/api/helpers.py         |   33 +-
 monasca_tempest_tests/tests/api/test_dimensions.py |    8 +-
 monasca_tempest_tests/tests/api/test_statistics.py |    3 +-
 19 files changed, 1143 insertions(+), 678 deletions(-)
 delete mode 100644 devstack/files/cassandra/cassandra_schema.cql
 create mode 100644 devstack/files/cassandra/monasca_schema.cql
 create mode 100644 monasca_api/conf/cassandra.py

Index: monasca-api-2.2.1.dev9/devstack/files/cassandra/monasca_schema.cql
===================================================================
--- /dev/null
+++ monasca-api-2.2.1.dev9/devstack/files/cassandra/monasca_schema.cql
@@ -0,0 +1,93 @@
+// (C) Copyright 2017 SUSE LLC
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//   http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+// implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+// version 1.0
+
+drop schema if exists monasca;
+
+// replication factor is set to 1 for devstack installation
+
+create schema monasca with replication = { 'class' : 'SimpleStrategy', 'replication_factor' : 1 };
+
+create table monasca.measurements (
+    metric_id blob,
+    region text static,
+    tenant_id text static,
+    metric_name text static,
+    dimensions frozen<list<text>> static,
+    time_stamp timestamp,
+    value double,
+    value_meta text,
+    primary key (metric_id, time_stamp)
+)
+WITH CLUSTERING ORDER BY (time_stamp ASC);
+
+create table monasca.metrics (
+    region text,
+    tenant_id text,
+    metric_name text,
+    dimensions frozen<list<text>>,
+    dimension_names frozen<list<text>>,
+    metric_id blob,
+    created_at timestamp,
+    updated_at timestamp,
+    primary key ((region, tenant_id, metric_name), dimensions, dimension_names)
+);
+
+CREATE CUSTOM INDEX metrics_created_at_index ON monasca.metrics (created_at)
+USING 'org.apache.cassandra.index.sasi.SASIIndex';
+
+CREATE CUSTOM INDEX metrics_updated_at_index ON monasca.metrics (updated_at)
+USING 'org.apache.cassandra.index.sasi.SASIIndex';
+
+create table monasca.dimensions (
+    region text,
+    tenant_id text,
+    name text,
+    value text,
+    primary key ((region, tenant_id, name), value)
+);
+
+create table monasca.dimensions_metrics (
+    region text,
+    tenant_id text,
+    dimension_name text,
+    dimension_value text,
+    metric_name text,
+    primary key ((region, tenant_id, dimension_name, dimension_value), metric_name)
+);
+
+create table monasca.metrics_dimensions (
+    region text,
+    tenant_id text,
+    dimension_name text,
+    dimension_value text,
+    metric_name text,
+    primary key ((region, tenant_id, metric_name), dimension_name, dimension_value)
+);
+
+create table monasca.alarm_state_history (
+    tenant_id text,
+    alarm_id text,
+    time_stamp timestamp,
+    metric text,
+    old_state text,
+    new_state text,
+    reason text,
+    reason_data text,
+    sub_alarms text,
+    primary key ((tenant_id, alarm_id), time_stamp)
+);
+
Index: monasca-api-2.2.1.dev9/devstack/lib/persister.sh
===================================================================
--- monasca-api-2.2.1.dev9.orig/devstack/lib/persister.sh
+++ monasca-api-2.2.1.dev9/devstack/lib/persister.sh
@@ -1,7 +1,8 @@
 #!/bin/bash
 
 # Copyright 2017 FUJITSU LIMITED
-#
+# (C) Copyright 2017 SUSE LLC
+
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
 # a copy of the License at
@@ -53,6 +54,18 @@ else
     MONASCA_PERSISTER_CMD="/usr/bin/java ${MONASCA_PERSISTER_JAVA_OPTS} -cp ${MONASCA_PERSISTER_JAR} monasca.persister.PersisterApplication server ${MONASCA_PERSISTER_CONF}"
 fi
 
+if [[ "${MONASCA_METRICS_DB,,}" == 'cassandra' ]]; then
+    MONASCA_PERSISTER_BATCH_SIZE=100
+    MONASCA_PERSISTER_MAX_BATCH_TIME=10
+    MONASCA_PERSISTER_METRIC_THREADS=2
+    MONASCA_PERSISTER_COMMIT_BATCH_TIME=10000
+else
+    MONASCA_PERSISTER_BATCH_SIZE=100
+    MONASCA_PERSISTER_MAX_BATCH_TIME=15
+    MONASCA_PERSISTER_METRIC_THREADS=10
+    MONASCA_PERSISTER_COMMIT_BATCH_TIME=0
+fi
+
 is_monasca_persister_enabled() {
     is_service_enabled monasca-persister && return 0
     return 1
@@ -141,10 +154,12 @@ configure_monasca_persister_python() {
     iniset "$MONASCA_PERSISTER_CONF" kafka_metrics uri $SERVICE_HOST:9092
     iniset "$MONASCA_PERSISTER_CONF" kafka_metrics group_id 1_metrics
     iniset "$MONASCA_PERSISTER_CONF" kafka_metrics topic metrics
+    iniset "$MONASCA_PERSISTER_CONF" kafka_metrics batch_size 30
 
     iniset "$MONASCA_PERSISTER_CONF" kafka_alarm_history uri $SERVICE_HOST:9092
     iniset "$MONASCA_PERSISTER_CONF" kafka_alarm_history group_id 1_alarm-state-transitions
     iniset "$MONASCA_PERSISTER_CONF" kafka_alarm_history topic alarm-state-transitions
+    iniset "$MONASCA_PERSISTER_CONF" kafka_alarm_history batch_size 1
 
     iniset "$MONASCA_PERSISTER_CONF" zookeeper uri $SERVICE_HOST:2181
 
@@ -155,9 +170,32 @@ configure_monasca_persister_python() {
         iniset "$MONASCA_PERSISTER_CONF" influxdb password password
         iniset "$MONASCA_PERSISTER_CONF" repositories metrics_driver ${M_REPO_DRIVER_INFLUX}
         iniset "$MONASCA_PERSISTER_CONF" repositories alarm_state_history_driver ${AH_REPO_DRIVER_INFLUX}
-    else
-        iniset "$MONASCA_PERSISTER_CONF" cassandra cluster_ip_addresses ${SERVICE_HOST}
+    elif [[ "${MONASCA_METRICS_DB,,}" == 'cassandra' ]]; then
+        iniset "$MONASCA_PERSISTER_CONF" cassandra contact_points ${SERVICE_HOST}
+        iniset "$MONASCA_PERSISTER_CONF" cassandra port 9042
+        # iniset "$MONASCA_PERSISTER_CONF" cassandra user monasca
+        # iniset "$MONASCA_PERSISTER_CONF" cassandra password password
         iniset "$MONASCA_PERSISTER_CONF" cassandra keyspace monasca
+        iniset "$MONASCA_PERSISTER_CONF" cassandra local_data_center datacenter1
+        iniset "$MONASCA_PERSISTER_CONF" cassandra connection_timeout 5
+        iniset "$MONASCA_PERSISTER_CONF" cassandra read_timeout 60
+        iniset "$MONASCA_PERSISTER_CONF" cassandra max_write_retries 5
+        iniset "$MONASCA_PERSISTER_CONF" cassandra max_batches 250
+        iniset "$MONASCA_PERSISTER_CONF" cassandra max_definition_cache_size 1000000
+        # consistency level names:
+        # ANY(0),
+        # ONE(1),
+        # TWO(2),
+        # THREE(3),
+        # QUORUM(4),
+        # ALL(5),
+        # LOCAL_QUORUM(6),
+        # EACH_QUORUM(7),
+        # SERIAL(8),
+        # LOCAL_SERIAL(9),
+        # LOCAL_ONE(10);
+        iniset "$MONASCA_PERSISTER_CONF" cassandra consistency_level ONE
+        iniset "$MONASCA_PERSISTER_CONF" cassandra retention_policy 45
         iniset "$MONASCA_PERSISTER_CONF" repositories metrics_driver ${M_REPO_DRIVER_CASSANDRA}
         iniset "$MONASCA_PERSISTER_CONF" repositories alarm_state_history_driver ${AH_REPO_DRIVER_CASSANDRA}
     fi
@@ -190,11 +228,16 @@ configure_monasca_persister_java() {
         s|%ZOOKEEPER_HOST%|${SERVICE_HOST}|g;
         s|%VERTICA_HOST%|${SERVICE_HOST}|g;
         s|%INFLUXDB_HOST%|${SERVICE_HOST}|g;
+        s|%CASSANDRADB_HOST%|${SERVICE_HOST}|g;
         s|%MONASCA_PERSISTER_DB_TYPE%|${MONASCA_METRICS_DB}|g;
         s|%MONASCA_PERSISTER_BIND_HOST%|${MONASCA_PERSISTER_BIND_HOST}|g;
         s|%MONASCA_PERSISTER_APP_PORT%|${MONASCA_PERSISTER_APP_PORT}|g;
         s|%MONASCA_PERSISTER_ADMIN_PORT%|${MONASCA_PERSISTER_ADMIN_PORT}|g;
         s|%MONASCA_PERSISTER_LOG_DIR%|${MONASCA_PERSISTER_LOG_DIR}|g;
+        s|%MONASCA_PERSISTER_BATCH_SIZE%|${MONASCA_PERSISTER_BATCH_SIZE}|g;
+        s|%MONASCA_PERSISTER_MAX_BATCH_TIME%|${MONASCA_PERSISTER_MAX_BATCH_TIME}|g;
+        s|%MONASCA_PERSISTER_COMMIT_BATCH_TIME%|${MONASCA_PERSISTER_COMMIT_BATCH_TIME}|g;
+        s|%MONASCA_PERSISTER_METRIC_THREADS%|${MONASCA_PERSISTER_METRIC_THREADS}|g;
     " -i ${MONASCA_PERSISTER_CONF}
 
     ln -sf ${MONASCA_PERSISTER_CONF} ${MONASCA_PERSISTER_GATE_CONFIG}
Index: monasca-api-2.2.1.dev9/devstack/plugin.sh
===================================================================
--- monasca-api-2.2.1.dev9.orig/devstack/plugin.sh
+++ monasca-api-2.2.1.dev9/devstack/plugin.sh
@@ -1,6 +1,7 @@
 #
 # (C) Copyright 2015-2017 Hewlett Packard Enterprise Development LP
 # Copyright 2017 FUJITSU LIMITED
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -469,11 +470,13 @@ function install_monasca_cassandra {
     echo_summary "Install Monasca Cassandra"
 
     if [[ "$OFFLINE" != "True" ]]; then
-        sudo sh -c "echo 'deb http://www.apache.org/dist/cassandra/debian ${CASSANDRA_VERSION} main' > /etc/apt/sources.list.d/cassandra.list"
+        sudo sh -c "echo 'deb http://www.apache.org/dist/cassandra/debian ${CASSANDRA_VERSION} main' > /etc/apt/sources.list.d/cassandra.sources.list"
         REPOS_UPDATED=False
-        PUBLIC_KEY=`apt_get_update 2>&1 | awk '/NO_PUBKEY/ {print $21}'`
-        gpg --keyserver pgp.mit.edu --recv-keys ${PUBLIC_KEY}
-        gpg --export --armor ${PUBLIC_KEY} | sudo apt-key --keyring /etc/apt/trusted.gpg.d/cassandra.gpg add -
+        curl https://www.apache.org/dist/cassandra/KEYS | sudo apt-key add -
+        PUBLIC_KEY=`sudo apt_get update 2>&1 | awk '/NO_PUBKEY/ {print $NF}'`
+        if [ -n "${PUBLIC_KEY}" ]; then
+            sudo apt-key adv --keyserver pool.sks-keyservers.net --recv-key  ${PUBLIC_KEY}
+        fi
     fi
 
     REPOS_UPDATED=False
@@ -498,6 +501,8 @@ function install_monasca_cassandra {
     sleep 15s
 
     export CQLSH_NO_BUNDLED=true
+
+    # always needed for Monasca api
     pip_install_gr cassandra-driver
 
 }
@@ -554,15 +559,15 @@ function clean_monasca_cassandra {
 
     echo_summary "Clean Monasca Cassandra"
 
-    sudo rm -f /etc/cassandra/cassandra.yaml
+    apt_get -y purge cassandra
 
-    sudo rm -rf /var/log/cassandra
+    apt_get -y autoremove
 
-    sudo rm -rf /etc/cassandra
+    sudo rm -rf /var/lib/cassandra
 
-    apt_get -y purge cassandra
+    sudo rm -rf /var/log/cassandra
 
-    apt_get -y autoremove
+    sudo rm -rf /etc/cassandra
 
     sudo rm -f /etc/apt/sources.list.d/cassandra.list
 
@@ -595,8 +600,8 @@ function install_schema_metric_database_
 }
 
 function install_schema_metric_database_cassandra {
-    sudo cp -f "${MONASCA_API_DIR}"/devstack/files/cassandra/cassandra_schema.cql $MONASCA_SCHEMA_DIR/cassandra_schema.cql
-    /usr/bin/cqlsh ${SERVICE_HOST} -f $MONASCA_SCHEMA_DIR/cassandra_schema.cql
+    sudo cp -f "${MONASCA_API_DIR}"/devstack/files/cassandra/*.cql $MONASCA_SCHEMA_DIR
+    /usr/bin/cqlsh ${SERVICE_HOST} -f $MONASCA_SCHEMA_DIR/monasca_schema.cql
 }
 
 function install_schema_kafka_topics {
@@ -806,7 +811,7 @@ function configure_monasca_api_python {
         fi
         iniset "$MONASCA_API_CONF" database connection $dbAlarmUrl
         iniset "$MONASCA_API_CONF" repositories metrics_driver $dbMetricDriver
-        iniset "$MONASCA_API_CONF" cassandra cluster_ip_addresses $SERVICE_HOST
+        iniset "$MONASCA_API_CONF" cassandra contact_points $SERVICE_HOST
         iniset "$MONASCA_API_CONF" influxdb ip_address $SERVICE_HOST
         iniset "$MONASCA_API_CONF" influxdb port 8086
         iniset "$MONASCA_API_CONF" kafka uri "$SERVICE_HOST:9092"
Index: monasca-api-2.2.1.dev9/devstack/settings
===================================================================
--- monasca-api-2.2.1.dev9.orig/devstack/settings
+++ monasca-api-2.2.1.dev9/devstack/settings
@@ -97,7 +97,7 @@ INFLUXDB_PYTHON_VERSION=${INFLUXDB_PYTHO
 # INFLUXDB_VERSION=${INFLUXDB_VERSION:-0.9.5}
 
 VERTICA_VERSION=${VERTICA_VERSION:-8.0.0-0}
-CASSANDRA_VERSION=${CASSANDRA_VERSION:-37x}
+CASSANDRA_VERSION=${CASSANDRA_VERSION:-311x}
 # Kafka deb consists of the version of scala plus the version of kafka
 BASE_KAFKA_VERSION=${BASE_KAFKA_VERSION:-0.9.0.1}
 SCALA_VERSION=${SCALA_VERSION:-2.11}
Index: monasca-api-2.2.1.dev9/monasca_api/common/repositories/cassandra/metrics_repository.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/common/repositories/cassandra/metrics_repository.py
+++ monasca-api-2.2.1.dev9/monasca_api/common/repositories/cassandra/metrics_repository.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2015,2016 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
